package ga;

import ga.listeners.GAConsoleListener;
import ga.core.GAProblem;
import ga.core.GAIndividual;
import ga.core.GAParams;
import problems.face.FaceDetectorProblem1;
import ac.essex.ooechs.imaging.commons.StatisticsSolver;

import java.text.DecimalFormat;

/**
 * <p/>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version,
 * provided that any use properly credits the author.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details at http://www.gnu.org
 * </p>
 *
 * @author Olly Oechsle, University of Essex, Date: 21-May-2007
 * @version 1.0
 */
public class FindParams {

    public static void main(String[] args) {

        GAProblem p = new FaceDetectorProblem1(5);

        DecimalFormat f = new DecimalFormat("0.0");

        for (double pXover = 0.0; pXover < 1.0; pXover += 0.1) {
            for (double pMutate = 0.0; pMutate < 1.0; pMutate += 0.1) {

                StatisticsSolver fitness = new StatisticsSolver();

                for (int run = 0; run < 5; run++) {

                    Evolve e = new Evolve(p, new GAConsoleListener(true));
                    GAParams params = e.getParams();
                    params.setCrossoverProbability(pXover);
                    params.setMutationProbability(pMutate);

                    e.run();
                    GAIndividual ind = e.getBestIndividual();
                    fitness.addData(ind.getKozaFitness());

                }

                System.out.println(f.format(pXover) + ", " + f.format(pMutate) + ", " + fitness.getMean() + ", " + fitness.getStandardDeviation());

            }
        }


    }

}
