package ga.classification;

/**
 * <p/>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version,
 * provided that any use properly credits the author.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details at http://www.gnu.org
 * </p>
 *
 * @author Olly Oechsle, University of Essex, Date: 21-May-2007
 * @version 1.0
 */
public class BinaryClassifier implements Classifier {

    public static final int FALSE = 0;
    public static final int TRUE = 1;

    public static final int OVER = 1;
    public static final int UNDER = 2;

    protected double threshold;
    protected int polarity;

    public BinaryClassifier(double threshold, int polarity) {
        this.threshold = threshold;
        this.polarity = polarity;
    }

    public int classify(double value) {
        if (polarity == OVER) {
            return value > threshold? TRUE : FALSE;
        } else {
            return value < threshold? TRUE : FALSE;
        }
    }

    public String toJava(String value) {
        if (polarity == OVER) {
            return "(" + value + ") > " + threshold + "? BinaryClassifier.TRUE : BinaryClassifier.FALSE";
        } else {
            return "(" + value + ") < " + threshold + "? BinaryClassifier.TRUE : BinaryClassifier.FALSE";
        }
    }

}
