package ga.core;

import ga.core.GAIndividual;
import ga.core.GAParams;
import ga.Evolve;

import java.util.Vector;

/**
 * <p/>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version,
 * provided that any use properly credits the author.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details at http://www.gnu.org
 * </p>
 *
 * @author Olly Oechsle, University of Essex, Date: 18-May-2007
 * @version 1.0
 */
public class GATournamentSelection {

    protected int tournamentSize;
    protected Vector<GAIndividual> population;

    public GATournamentSelection(GAParams params, Vector<GAIndividual> population) {
        tournamentSize = params.getTournamentSize();
        this.population = population;
    }

    public GAIndividual select() {
        GAIndividual best = null;
        for (int i = 0; i < tournamentSize; i++) {
            GAIndividual ind = getRandomIndividual();
            if (best == null || ind.getKozaFitness() < best.getKozaFitness()) best = ind;
        }
        return best;
    }

    private GAIndividual getRandomIndividual() {
        return population.get((int) (Evolve.getRandomNumber() * population.size()));
    }

}
