package ga.listeners;

import ga.core.GAProblem;
import ga.core.GAIndividual;

/**
 * <p/>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version,
 * provided that any use properly credits the author.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details at http://www.gnu.org
 * </p>
 *
 * @author Olly Oechsle, University of Essex, Date: 21-May-2007
 * @version 1.0
 */
public class GAConsoleListener extends GAListener {

    protected boolean silent;

    public GAConsoleListener(boolean silent) {
        this.silent = silent;
    }

    public void initialise(GAProblem p) {
        println("sxGA Version 1.0");
    }

    public void onGenerationStart(int generation) {
        //println("Generation " + generation + ":");
    }

    public void onGenerationEnd(int generation, GAIndividual bestIndividual) {
        //println("f= " + bestIndividual.getKozaFitness() + ", hits=" + bestIndividual.getHits() + ", values=" + bestIndividual.toJava());
        println(bestIndividual.getKozaFitness() + ", " + bestIndividual.alternativeFitness);
    }

    public void onEvolutionEnd(int generation, GAIndividual bestIndividual) {

        if (bestIndividual.getKozaFitness() == 0) {
            println("(Found Ideal Individual)");
        } else {
            println("(Evolution stopped)");
        }

        println("Gen=" + generation + ", f= " + bestIndividual.getKozaFitness() + ", hits=" + bestIndividual.getHits() + ", values=" + bestIndividual.toJava());

        
    }

    private void println(String message) {
        if (!silent) {
            System.out.println(message);
        }
    }

}
