package ga.listeners;

import ga.core.GAProblem;
import ga.core.GAIndividual;

/**
 * Provides user output from the GA algorithm
 *
 * @author Olly Oechsle, University of Essex, Date: 21-May-2007
 * @version 1.0
 */
public abstract class GAListener {

    private long startTime;

    public abstract void initialise(GAProblem p);

    public abstract void onGenerationStart(int generation);

    public abstract void onGenerationEnd(int generation, GAIndividual bestIndividual);

    public final void onEvolutionStart() {
        startTime = System.currentTimeMillis();
    }

    public long getTimeElapsed() {
        return System.currentTimeMillis() - startTime;
    }

    public abstract void onEvolutionEnd(int generation, GAIndividual bestIndividual);

}
