package problems.face;

import ga.core.GAProblem;
import ga.core.GAParams;
import ga.core.GAIndividual;
import ga.Evolve;
import ga.listeners.GAConsoleListener;
import ga.listeners.GAGraphicalListener;
import ac.essex.ooechs.imaging.commons.HaarRegions;
import ac.essex.ooechs.imaging.commons.PixelLoader;

/**
 * <p/>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version,
 * provided that any use properly credits the author.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details at http://www.gnu.org
 * </p>
 *
 * @author Olly Oechsle, University of Essex, Date: 31-Oct-2007
 * @version 1.0
 */
public class FaceDetectorProblem2 extends GAProblem {

    HaarRegions image;

    public static void main(String[] args) throws Exception {
        for (int i = 0; i < 10; i++) {
            new Evolve(new FaceDetectorProblem2(), new GAConsoleListener(false)).run();
        }
    }

    public FaceDetectorProblem2() throws Exception {
        image = new HaarRegions(new PixelLoader("/home/ooechs/Data/faces/blended.bmp"));
        image.makeWindowFillImage(19, 19);
    }

    public String getName() {
        return "Face Detector Problem";
    }

    public GAIndividual createIndividual() {
        return new FaceDetectorIndividual(0, 0, FaceDetectorIndividual.ONE_RECT);
    }

    public void evaluate(GAIndividual ind) {
        double result = ind.execute(image);
        if (result == 0) ind.setWorstFitness();
        else ind.setKozaFitness(1 / result);
    }

}
