package problems.face.util;

import ac.essex.ooechs.imaging.commons.HaarRegions;
import ac.essex.ooechs.adaboost.AdaBoostSample;
import problems.face.FaceDetectorProblem1;
import ga.Evolve;

/**
 * @author Olly Oechsle, University of Essex, Date: 22-May-2007
 * @version 1.0
 */
public class FaceSample extends AdaBoostSample {

    public HaarRegions image;

    public int classID;

    private int x, y;

    public FaceSample(HaarRegions image, int classID) {

        super(image, classID);

        this.image = image;
        this.classID = classID;

        if (classID == FaceDetectorProblem1.FACE) {
            x = 0;
            y = 0;
        } else {
            x =  (int) (Evolve.getRandomNumber() * (image.getWidth() - FaceDetectorProblem1.WINDOW_WIDTH));
            y =  (int) (Evolve.getRandomNumber() * (image.getHeight() - FaceDetectorProblem1.WINDOW_HEIGHT));
        }

    }

    public void initHaar() {
        if (classID == FaceDetectorProblem1.FACE) {
            image.makeWindowFillImage(FaceDetectorProblem1.WINDOWBLOCKSX, FaceDetectorProblem1.WINDOWBLOCKSY);
        } else {
            image.setWindowPosition(x, y, FaceDetectorProblem1.WINDOW_WIDTH, FaceDetectorProblem1.WINDOW_HEIGHT, FaceDetectorProblem1.WINDOWBLOCKSX, FaceDetectorProblem1.WINDOWBLOCKSY);
        }
    }

}
